diff --git a/doc/org.bluez.AdvertisementMonitorManager.rst b/doc/org.bluez.AdvertisementMonitorManager.rst
index 3775a4835..477a0e9e2 100644
--- a/doc/org.bluez.AdvertisementMonitorManager.rst
+++ b/doc/org.bluez.AdvertisementMonitorManager.rst
@@ -14,9 +14,9 @@ BlueZ D-Bus AdvertisementMonitorManager API documentation
 Interface
 =========
 
-Service		org.bluez
-Interface	org.bluez.AdvertisementMonitorManager1 [experimental]
-Object path	/org/bluez/{hci0,hci1,...}
+:Service:	org.bluez
+:Interface:	org.bluez.AdvertisementMonitorManager1 [experimental]
+:Object path:	/org/bluez/{hci0,hci1,...}
 
 Methods
 -------
diff --git a/doc/org.bluez.Agent.rst b/doc/org.bluez.Agent.rst
index 11d09b94d..6b6d75edb 100644
--- a/doc/org.bluez.Agent.rst
+++ b/doc/org.bluez.Agent.rst
@@ -9,7 +9,7 @@ BlueZ D-Bus Agent API documentation
 :Version: BlueZ
 :Date: October 2023
 :Manual section: 5
-:Manual group: Linux System Administration
+:Manual group: Linux System Administration
 
 Interface
 =========
diff --git a/doc/org.bluez.AgentManager.rst b/doc/org.bluez.AgentManager.rst
index dfc0297da..fadadecb1 100644
--- a/doc/org.bluez.AgentManager.rst
+++ b/doc/org.bluez.AgentManager.rst
@@ -9,7 +9,7 @@ BlueZ D-Bus AgentManager API documentation
 :Version: BlueZ
 :Date: October 2023
 :Manual section: 5
-:Manual group: Linux System Administration
+:Manual group: Linux System Administration
 
 Interface
 =========
@@ -80,4 +80,3 @@ void RequestDefaultAgent(object agent)
 	Possible errors:
 
 	:org.bluez.Error.DoesNotExist:
-
diff --git a/doc/org.bluez.GattCharacteristic.rst b/doc/org.bluez.GattCharacteristic.rst
index 7b1b3fbb5..bdb3476fb 100644
--- a/doc/org.bluez.GattCharacteristic.rst
+++ b/doc/org.bluez.GattCharacteristic.rst
@@ -50,11 +50,11 @@ array{byte} ReadValue(dict options)
 
 	Possible options:
 
-	:uint16_t offset:
+	:uint16 offset:
 
 		Read start offset in bytes.
 
-	:uint16_t mtu (server only):
+	:uint16 mtu (server only):
 
 		Exchange MTU in bytes.
 
diff --git a/doc/org.bluez.GattDescriptor.rst b/doc/org.bluez.GattDescriptor.rst
index f4497c6d5..536ef0ca7 100644
--- a/doc/org.bluez.GattDescriptor.rst
+++ b/doc/org.bluez.GattDescriptor.rst
@@ -50,7 +50,7 @@ array{byte} ReadValue(dict flags)
 
 	Possible options:
 
-	:uint16_t offset:
+	:uint16 offset:
 
 		Read start offset in bytes.
 
diff --git a/doc/org.bluez.LEAdvertisement.rst b/doc/org.bluez.LEAdvertisement.rst
index bab507439..b998f40a2 100644
--- a/doc/org.bluez.LEAdvertisement.rst
+++ b/doc/org.bluez.LEAdvertisement.rst
@@ -177,13 +177,13 @@ uint16 Appearance [readonly, optional]
 
 	Possible values: as found on GAP Service.
 
-uint16_t Duration [readonly, optional]
+uint16 Duration [readonly, optional]
 ``````````````````````````````````````
 
 	Rotation duration of the advertisement in seconds. If there are other
 	applications advertising no duration is set the default is 2 seconds.
 
-uint16_t Timeout [readonly, optional]
+uint16 Timeout [readonly, optional]
 `````````````````````````````````````
 
 	Timeout of the advertisement in seconds. This defines the lifetime of
diff --git a/doc/org.bluez.LEAdvertisingManager.rst b/doc/org.bluez.LEAdvertisingManager.rst
index 7f6359dff..93eac411a 100644
--- a/doc/org.bluez.LEAdvertisingManager.rst
+++ b/doc/org.bluez.LEAdvertisingManager.rst
@@ -117,7 +117,7 @@ dict SupportedCapabilities [readonly]
 
 		Max advertising scan response length
 
-	;int16 MinTxPower:
+	:int16 MinTxPower:
 
 		Min advertising tx power (dBm)
 
diff --git a/doc/org.bluez.Media.rst b/doc/org.bluez.Media.rst
index 678e6090c..ecd982652 100644
--- a/doc/org.bluez.Media.rst
+++ b/doc/org.bluez.Media.rst
@@ -14,9 +14,9 @@ BlueZ D-Bus Media API documentation
 Interface
 =========
 
-:Service: org.bluez
-:Interface: org.bluez.Media1
-:Object path: [variable prefix]/{hci0,hci1,...}
+:Service:	org.bluez
+:Interface:	org.bluez.Media1
+:Object path:	[variable prefix]/{hci0,hci1,...}
 
 Methods
 -------
diff --git a/doc/org.bluez.obex.Agent.rst b/doc/org.bluez.obex.Agent.rst
index b832e278c..74e014570 100644
--- a/doc/org.bluez.obex.Agent.rst
+++ b/doc/org.bluez.obex.Agent.rst
@@ -14,7 +14,7 @@ BlueZ D-Bus OBEX Agent API documentation
 Interface
 =========
 
-;Service:	unique name
+:Service:	unique name
 :Interface:	org.bluez.obex.Agent1
 :Object path:	freely definable
 
diff --git a/doc/org.bluez.obex.AgentManager.rst b/doc/org.bluez.obex.AgentManager.rst
index f18f227bc..cdacd4d2f 100644
--- a/doc/org.bluez.obex.AgentManager.rst
+++ b/doc/org.bluez.obex.AgentManager.rst
@@ -19,7 +19,7 @@ Interface
 :Object path:	/org/bluez/obex
 
 Methods
-```````
+-------
 
 void RegisterAgent(object agent)
 ````````````````````````````````
diff --git a/doc/org.bluez.obex.FileTransfer.rst b/doc/org.bluez.obex.FileTransfer.rst
index 6dce7e59d..b0a2f8495 100644
--- a/doc/org.bluez.obex.FileTransfer.rst
+++ b/doc/org.bluez.obex.FileTransfer.rst
@@ -141,7 +141,7 @@ void MoveFile(string sourcefile, string targetfile)
 
 	Possible errors:
 
-	;org.bluez.obex.Error.InvalidArguments:
+	:org.bluez.obex.Error.InvalidArguments:
 	:org.bluez.obex.Error.Failed:
 
 void Delete(string file)